/**
 * Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

var data = require('../../core/data');

var nested = {
	count: 0,

	add: function(){
		this.count ++;
	},

	sub: function(){
		this.count --;
	},

	getCount: function(){
		return this.count;
	},

	createFnForBegin: function(arr){
		var me = this;
		var fn = function(){
			me.add();
		};

		fn.__isIgnore = true;
		arr.push(fn);
	},

	createFnForEnd: function(arr){
		var me = this;
		var fn = function(){
			me.sub();
		};

		fn.__isIgnore = true;
		arr.push(fn);
	},

	createFnForAdd: function(fnName, arr, deep){
		var me = this;
		var fn = function(){
			me.add();
		};

		fn.treeIndent = this.getCount() + deep;
		fn.__isIgnore = true;
		fn.__label = fnName;
		arr.push(fn);
	},

	createFnForSub: function(arr, deep){
		var me = this;
		var fn = function(){
			!data.flag.isAwait && me.sub();
		};

		fn.treeIndent = this.getCount() + deep;
		fn.__isIgnore = true;
		arr.push(fn);
	}
};

module.exports.__proto__ = nested;
